/*
 * generated by Xtext 2.19.0
 */
package fr.istic.services;

import com.google.inject.Inject;
import com.google.inject.Singleton;
import java.util.List;
import org.eclipse.xtext.Alternatives;
import org.eclipse.xtext.Assignment;
import org.eclipse.xtext.EnumLiteralDeclaration;
import org.eclipse.xtext.EnumRule;
import org.eclipse.xtext.Grammar;
import org.eclipse.xtext.GrammarUtil;
import org.eclipse.xtext.Group;
import org.eclipse.xtext.Keyword;
import org.eclipse.xtext.ParserRule;
import org.eclipse.xtext.RuleCall;
import org.eclipse.xtext.TerminalRule;
import org.eclipse.xtext.common.services.TerminalsGrammarAccess;
import org.eclipse.xtext.service.AbstractElementFinder.AbstractEnumRuleElementFinder;
import org.eclipse.xtext.service.AbstractElementFinder.AbstractGrammarElementFinder;
import org.eclipse.xtext.service.GrammarProvider;

@Singleton
public class MMLGrammarAccess extends AbstractGrammarElementFinder {
	
	public class MMLModelElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "fr.istic.MML.MMLModel");
		private final Group cGroup = (Group)rule.eContents().get(1);
		private final Assignment cInputAssignment_0 = (Assignment)cGroup.eContents().get(0);
		private final RuleCall cInputDataInputParserRuleCall_0_0 = (RuleCall)cInputAssignment_0.eContents().get(0);
		private final Assignment cMlChoiceAssignment_1 = (Assignment)cGroup.eContents().get(1);
		private final RuleCall cMlChoiceMLChoiceParserRuleCall_1_0 = (RuleCall)cMlChoiceAssignment_1.eContents().get(0);
		private final Assignment cVariablesAssignment_2 = (Assignment)cGroup.eContents().get(2);
		private final RuleCall cVariablesVariablesParserRuleCall_2_0 = (RuleCall)cVariablesAssignment_2.eContents().get(0);
		private final Assignment cEvaluationAssignment_3 = (Assignment)cGroup.eContents().get(3);
		private final RuleCall cEvaluationEvaluationParserRuleCall_3_0 = (RuleCall)cEvaluationAssignment_3.eContents().get(0);
		
		//MMLModel:
		//	input=DataInput
		//	mlChoice=MLChoice
		//	variables=Variables
		//	evaluation=Evaluation;
		@Override public ParserRule getRule() { return rule; }
		
		//input=DataInput mlChoice=MLChoice variables=Variables evaluation=Evaluation
		public Group getGroup() { return cGroup; }
		
		//input=DataInput
		public Assignment getInputAssignment_0() { return cInputAssignment_0; }
		
		//DataInput
		public RuleCall getInputDataInputParserRuleCall_0_0() { return cInputDataInputParserRuleCall_0_0; }
		
		//mlChoice=MLChoice
		public Assignment getMlChoiceAssignment_1() { return cMlChoiceAssignment_1; }
		
		//MLChoice
		public RuleCall getMlChoiceMLChoiceParserRuleCall_1_0() { return cMlChoiceMLChoiceParserRuleCall_1_0; }
		
		//variables=Variables
		public Assignment getVariablesAssignment_2() { return cVariablesAssignment_2; }
		
		//Variables
		public RuleCall getVariablesVariablesParserRuleCall_2_0() { return cVariablesVariablesParserRuleCall_2_0; }
		
		//evaluation=Evaluation
		public Assignment getEvaluationAssignment_3() { return cEvaluationAssignment_3; }
		
		//Evaluation
		public RuleCall getEvaluationEvaluationParserRuleCall_3_0() { return cEvaluationEvaluationParserRuleCall_3_0; }
	}
	public class COMMAElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "fr.istic.MML.COMMA");
		private final Keyword cCommaKeyword = (Keyword)rule.eContents().get(1);
		
		//fragment COMMA:
		//	',';
		@Override public ParserRule getRule() { return rule; }
		
		//','
		public Keyword getCommaKeyword() { return cCommaKeyword; }
	}
	public class SEMICOLONElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "fr.istic.MML.SEMICOLON");
		private final Keyword cSemicolonKeyword = (Keyword)rule.eContents().get(1);
		
		//fragment SEMICOLON:
		//	';';
		@Override public ParserRule getRule() { return rule; }
		
		//';'
		public Keyword getSemicolonKeyword() { return cSemicolonKeyword; }
	}
	public class NEWLINEElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "fr.istic.MML.NEWLINE");
		private final Keyword cLineFeedKeyword = (Keyword)rule.eContents().get(1);
		
		//fragment NEWLINE:
		//	"\n";
		@Override public ParserRule getRule() { return rule; }
		
		//"\n"
		public Keyword getLineFeedKeyword() { return cLineFeedKeyword; }
	}
	public class DataInputElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "fr.istic.MML.DataInput");
		private final Group cGroup = (Group)rule.eContents().get(1);
		private final Keyword cDataSetKeyword_0 = (Keyword)cGroup.eContents().get(0);
		private final Assignment cFileAssignment_1 = (Assignment)cGroup.eContents().get(1);
		private final RuleCall cFileSTRINGTerminalRuleCall_1_0 = (RuleCall)cFileAssignment_1.eContents().get(0);
		private final Assignment cCsvSeparatorAssignment_2 = (Assignment)cGroup.eContents().get(2);
		private final RuleCall cCsvSeparatorCSVSeparatorParserRuleCall_2_0 = (RuleCall)cCsvSeparatorAssignment_2.eContents().get(0);
		private final RuleCall cSEMICOLONParserRuleCall_3 = (RuleCall)cGroup.eContents().get(3);
		private final RuleCall cNEWLINEParserRuleCall_4 = (RuleCall)cGroup.eContents().get(4);
		
		//// Read dataset
		//DataInput:
		//	'dataSet' file=STRING csvSeparator=CSVSeparator? SEMICOLON NEWLINE;
		@Override public ParserRule getRule() { return rule; }
		
		//'dataSet' file=STRING csvSeparator=CSVSeparator? SEMICOLON NEWLINE
		public Group getGroup() { return cGroup; }
		
		//'dataSet'
		public Keyword getDataSetKeyword_0() { return cDataSetKeyword_0; }
		
		//file=STRING
		public Assignment getFileAssignment_1() { return cFileAssignment_1; }
		
		//STRING
		public RuleCall getFileSTRINGTerminalRuleCall_1_0() { return cFileSTRINGTerminalRuleCall_1_0; }
		
		//csvSeparator=CSVSeparator?
		public Assignment getCsvSeparatorAssignment_2() { return cCsvSeparatorAssignment_2; }
		
		//CSVSeparator
		public RuleCall getCsvSeparatorCSVSeparatorParserRuleCall_2_0() { return cCsvSeparatorCSVSeparatorParserRuleCall_2_0; }
		
		//SEMICOLON
		public RuleCall getSEMICOLONParserRuleCall_3() { return cSEMICOLONParserRuleCall_3; }
		
		//NEWLINE
		public RuleCall getNEWLINEParserRuleCall_4() { return cNEWLINEParserRuleCall_4; }
	}
	public class CSVSeparatorElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "fr.istic.MML.CSVSeparator");
		private final Group cGroup = (Group)rule.eContents().get(1);
		private final Keyword cSeparatorKeyword_0 = (Keyword)cGroup.eContents().get(0);
		private final Assignment cSeparatorAssignment_1 = (Assignment)cGroup.eContents().get(1);
		private final RuleCall cSeparatorSTRINGTerminalRuleCall_1_0 = (RuleCall)cSeparatorAssignment_1.eContents().get(0);
		
		//CSVSeparator:
		//	'separator' separator=STRING;
		@Override public ParserRule getRule() { return rule; }
		
		//'separator' separator=STRING
		public Group getGroup() { return cGroup; }
		
		//'separator'
		public Keyword getSeparatorKeyword_0() { return cSeparatorKeyword_0; }
		
		//separator=STRING
		public Assignment getSeparatorAssignment_1() { return cSeparatorAssignment_1; }
		
		//STRING
		public RuleCall getSeparatorSTRINGTerminalRuleCall_1_0() { return cSeparatorSTRINGTerminalRuleCall_1_0; }
	}
	public class MLChoiceElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "fr.istic.MML.MLChoice");
		private final Group cGroup = (Group)rule.eContents().get(1);
		private final Keyword cMlFrameworkKeyword_0 = (Keyword)cGroup.eContents().get(0);
		private final Assignment cFrameworkAssignment_1 = (Assignment)cGroup.eContents().get(1);
		private final RuleCall cFrameworkMLFrameworkEnumRuleCall_1_0 = (RuleCall)cFrameworkAssignment_1.eContents().get(0);
		private final RuleCall cCOMMAParserRuleCall_2 = (RuleCall)cGroup.eContents().get(2);
		private final Keyword cMlAlgorithmKeyword_3 = (Keyword)cGroup.eContents().get(3);
		private final Assignment cAlgorithmAssignment_4 = (Assignment)cGroup.eContents().get(4);
		private final RuleCall cAlgorithmMLAlgorithmParserRuleCall_4_0 = (RuleCall)cAlgorithmAssignment_4.eContents().get(0);
		private final RuleCall cSEMICOLONParserRuleCall_5 = (RuleCall)cGroup.eContents().get(5);
		private final RuleCall cNEWLINEParserRuleCall_6 = (RuleCall)cGroup.eContents().get(6);
		
		//// Choose ML Algorithm
		//MLChoice:
		//	'mlFramework' framework=MLFramework COMMA
		//	'mlAlgorithm' algorithm=MLAlgorithm SEMICOLON NEWLINE;
		@Override public ParserRule getRule() { return rule; }
		
		//'mlFramework' framework=MLFramework COMMA 'mlAlgorithm' algorithm=MLAlgorithm SEMICOLON NEWLINE
		public Group getGroup() { return cGroup; }
		
		//'mlFramework'
		public Keyword getMlFrameworkKeyword_0() { return cMlFrameworkKeyword_0; }
		
		//framework=MLFramework
		public Assignment getFrameworkAssignment_1() { return cFrameworkAssignment_1; }
		
		//MLFramework
		public RuleCall getFrameworkMLFrameworkEnumRuleCall_1_0() { return cFrameworkMLFrameworkEnumRuleCall_1_0; }
		
		//COMMA
		public RuleCall getCOMMAParserRuleCall_2() { return cCOMMAParserRuleCall_2; }
		
		//'mlAlgorithm'
		public Keyword getMlAlgorithmKeyword_3() { return cMlAlgorithmKeyword_3; }
		
		//algorithm=MLAlgorithm
		public Assignment getAlgorithmAssignment_4() { return cAlgorithmAssignment_4; }
		
		//MLAlgorithm
		public RuleCall getAlgorithmMLAlgorithmParserRuleCall_4_0() { return cAlgorithmMLAlgorithmParserRuleCall_4_0; }
		
		//SEMICOLON
		public RuleCall getSEMICOLONParserRuleCall_5() { return cSEMICOLONParserRuleCall_5; }
		
		//NEWLINE
		public RuleCall getNEWLINEParserRuleCall_6() { return cNEWLINEParserRuleCall_6; }
	}
	public class MLAlgorithmElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "fr.istic.MML.MLAlgorithm");
		private final Alternatives cAlternatives = (Alternatives)rule.eContents().get(1);
		private final RuleCall cRegressionTreeParserRuleCall_0 = (RuleCall)cAlternatives.eContents().get(0);
		private final RuleCall cLinearRegressionParserRuleCall_1 = (RuleCall)cAlternatives.eContents().get(1);
		
		//MLAlgorithm:
		//	RegressionTree | LinearRegression;
		@Override public ParserRule getRule() { return rule; }
		
		//RegressionTree | LinearRegression
		public Alternatives getAlternatives() { return cAlternatives; }
		
		//RegressionTree
		public RuleCall getRegressionTreeParserRuleCall_0() { return cRegressionTreeParserRuleCall_0; }
		
		//LinearRegression
		public RuleCall getLinearRegressionParserRuleCall_1() { return cLinearRegressionParserRuleCall_1; }
	}
	public class RegressionTreeElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "fr.istic.MML.RegressionTree");
		private final Assignment cRegressionTreeAssignment = (Assignment)rule.eContents().get(1);
		private final Keyword cRegressionTreeRegressionTreeKeyword_0 = (Keyword)cRegressionTreeAssignment.eContents().get(0);
		
		//RegressionTree:
		//	regressionTree='RegressionTree';
		@Override public ParserRule getRule() { return rule; }
		
		//regressionTree='RegressionTree'
		public Assignment getRegressionTreeAssignment() { return cRegressionTreeAssignment; }
		
		//'RegressionTree'
		public Keyword getRegressionTreeRegressionTreeKeyword_0() { return cRegressionTreeRegressionTreeKeyword_0; }
	}
	public class LinearRegressionElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "fr.istic.MML.LinearRegression");
		private final Assignment cLinearRegressionAssignment = (Assignment)rule.eContents().get(1);
		private final Keyword cLinearRegressionLinearRegressionKeyword_0 = (Keyword)cLinearRegressionAssignment.eContents().get(0);
		
		//LinearRegression:
		//	linearRegression='LinearRegression';
		@Override public ParserRule getRule() { return rule; }
		
		//linearRegression='LinearRegression'
		public Assignment getLinearRegressionAssignment() { return cLinearRegressionAssignment; }
		
		//'LinearRegression'
		public Keyword getLinearRegressionLinearRegressionKeyword_0() { return cLinearRegressionLinearRegressionKeyword_0; }
	}
	public class VariablesElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "fr.istic.MML.Variables");
		private final Group cGroup = (Group)rule.eContents().get(1);
		private final Keyword cVariablesKeyword_0 = (Keyword)cGroup.eContents().get(0);
		private final Keyword cPredictionKeyword_1 = (Keyword)cGroup.eContents().get(1);
		private final Assignment cPredictionsAssignment_2 = (Assignment)cGroup.eContents().get(2);
		private final RuleCall cPredictionsPredictionsParserRuleCall_2_0 = (RuleCall)cPredictionsAssignment_2.eContents().get(0);
		private final RuleCall cCOMMAParserRuleCall_3 = (RuleCall)cGroup.eContents().get(3);
		private final Keyword cTargetKeyword_4 = (Keyword)cGroup.eContents().get(4);
		private final Assignment cTargetAssignment_5 = (Assignment)cGroup.eContents().get(5);
		private final RuleCall cTargetTargetParserRuleCall_5_0 = (RuleCall)cTargetAssignment_5.eContents().get(0);
		private final RuleCall cSEMICOLONParserRuleCall_6 = (RuleCall)cGroup.eContents().get(6);
		private final RuleCall cNEWLINEParserRuleCall_7 = (RuleCall)cGroup.eContents().get(7);
		
		//// Specify predictions and target variables
		//Variables:
		//	'variables'
		//	'prediction' predictions=Predictions COMMA
		//	'target' target=Target SEMICOLON NEWLINE;
		@Override public ParserRule getRule() { return rule; }
		
		//'variables' 'prediction' predictions=Predictions COMMA 'target' target=Target SEMICOLON NEWLINE
		public Group getGroup() { return cGroup; }
		
		//'variables'
		public Keyword getVariablesKeyword_0() { return cVariablesKeyword_0; }
		
		//'prediction'
		public Keyword getPredictionKeyword_1() { return cPredictionKeyword_1; }
		
		//predictions=Predictions
		public Assignment getPredictionsAssignment_2() { return cPredictionsAssignment_2; }
		
		//Predictions
		public RuleCall getPredictionsPredictionsParserRuleCall_2_0() { return cPredictionsPredictionsParserRuleCall_2_0; }
		
		//COMMA
		public RuleCall getCOMMAParserRuleCall_3() { return cCOMMAParserRuleCall_3; }
		
		//'target'
		public Keyword getTargetKeyword_4() { return cTargetKeyword_4; }
		
		//target=Target
		public Assignment getTargetAssignment_5() { return cTargetAssignment_5; }
		
		//Target
		public RuleCall getTargetTargetParserRuleCall_5_0() { return cTargetTargetParserRuleCall_5_0; }
		
		//SEMICOLON
		public RuleCall getSEMICOLONParserRuleCall_6() { return cSEMICOLONParserRuleCall_6; }
		
		//NEWLINE
		public RuleCall getNEWLINEParserRuleCall_7() { return cNEWLINEParserRuleCall_7; }
	}
	public class TargetElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "fr.istic.MML.Target");
		private final Alternatives cAlternatives = (Alternatives)rule.eContents().get(1);
		private final RuleCall cDefaultTargetParserRuleCall_0 = (RuleCall)cAlternatives.eContents().get(0);
		private final RuleCall cNamedTargetParserRuleCall_1 = (RuleCall)cAlternatives.eContents().get(1);
		
		//Target:
		//	DefaultTarget | NamedTarget;
		@Override public ParserRule getRule() { return rule; }
		
		//DefaultTarget | NamedTarget
		public Alternatives getAlternatives() { return cAlternatives; }
		
		//DefaultTarget
		public RuleCall getDefaultTargetParserRuleCall_0() { return cDefaultTargetParserRuleCall_0; }
		
		//NamedTarget
		public RuleCall getNamedTargetParserRuleCall_1() { return cNamedTargetParserRuleCall_1; }
	}
	public class DefaultTargetElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "fr.istic.MML.DefaultTarget");
		private final Assignment cDefaultAssignment = (Assignment)rule.eContents().get(1);
		private final Keyword cDefaultDefaultKeyword_0 = (Keyword)cDefaultAssignment.eContents().get(0);
		
		//DefaultTarget:
		//	default='default';
		@Override public ParserRule getRule() { return rule; }
		
		//default='default'
		public Assignment getDefaultAssignment() { return cDefaultAssignment; }
		
		//'default'
		public Keyword getDefaultDefaultKeyword_0() { return cDefaultDefaultKeyword_0; }
	}
	public class NamedTargetElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "fr.istic.MML.NamedTarget");
		private final Assignment cTargetAssignment = (Assignment)rule.eContents().get(1);
		private final RuleCall cTargetItemParserRuleCall_0 = (RuleCall)cTargetAssignment.eContents().get(0);
		
		//NamedTarget:
		//	target=Item;
		@Override public ParserRule getRule() { return rule; }
		
		//target=Item
		public Assignment getTargetAssignment() { return cTargetAssignment; }
		
		//Item
		public RuleCall getTargetItemParserRuleCall_0() { return cTargetItemParserRuleCall_0; }
	}
	public class PredictionsElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "fr.istic.MML.Predictions");
		private final Alternatives cAlternatives = (Alternatives)rule.eContents().get(1);
		private final RuleCall cAllVariablesParserRuleCall_0 = (RuleCall)cAlternatives.eContents().get(0);
		private final RuleCall cPredictorVariablesParserRuleCall_1 = (RuleCall)cAlternatives.eContents().get(1);
		
		//Predictions:
		//	AllVariables | PredictorVariables;
		@Override public ParserRule getRule() { return rule; }
		
		//AllVariables | PredictorVariables
		public Alternatives getAlternatives() { return cAlternatives; }
		
		//AllVariables
		public RuleCall getAllVariablesParserRuleCall_0() { return cAllVariablesParserRuleCall_0; }
		
		//PredictorVariables
		public RuleCall getPredictorVariablesParserRuleCall_1() { return cPredictorVariablesParserRuleCall_1; }
	}
	public class AllVariablesElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "fr.istic.MML.AllVariables");
		private final Assignment cAllAssignment = (Assignment)rule.eContents().get(1);
		private final Keyword cAllAllKeyword_0 = (Keyword)cAllAssignment.eContents().get(0);
		
		//AllVariables:
		//	all='all';
		@Override public ParserRule getRule() { return rule; }
		
		//all='all'
		public Assignment getAllAssignment() { return cAllAssignment; }
		
		//'all'
		public Keyword getAllAllKeyword_0() { return cAllAllKeyword_0; }
	}
	public class PredictorVariablesElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "fr.istic.MML.PredictorVariables");
		private final Group cGroup = (Group)rule.eContents().get(1);
		private final Assignment cVarsAssignment_0 = (Assignment)cGroup.eContents().get(0);
		private final RuleCall cVarsItemParserRuleCall_0_0 = (RuleCall)cVarsAssignment_0.eContents().get(0);
		private final Group cGroup_1 = (Group)cGroup.eContents().get(1);
		private final Keyword cPlusSignKeyword_1_0 = (Keyword)cGroup_1.eContents().get(0);
		private final Assignment cVarsAssignment_1_1 = (Assignment)cGroup_1.eContents().get(1);
		private final RuleCall cVarsItemParserRuleCall_1_1_0 = (RuleCall)cVarsAssignment_1_1.eContents().get(0);
		
		//PredictorVariables:
		//	vars+=Item ("+" vars+=Item)*;
		@Override public ParserRule getRule() { return rule; }
		
		//vars+=Item ("+" vars+=Item)*
		public Group getGroup() { return cGroup; }
		
		//vars+=Item
		public Assignment getVarsAssignment_0() { return cVarsAssignment_0; }
		
		//Item
		public RuleCall getVarsItemParserRuleCall_0_0() { return cVarsItemParserRuleCall_0_0; }
		
		//("+" vars+=Item)*
		public Group getGroup_1() { return cGroup_1; }
		
		//"+"
		public Keyword getPlusSignKeyword_1_0() { return cPlusSignKeyword_1_0; }
		
		//vars+=Item
		public Assignment getVarsAssignment_1_1() { return cVarsAssignment_1_1; }
		
		//Item
		public RuleCall getVarsItemParserRuleCall_1_1_0() { return cVarsItemParserRuleCall_1_1_0; }
	}
	public class ItemElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "fr.istic.MML.Item");
		private final Assignment cColumnNameAssignment = (Assignment)rule.eContents().get(1);
		private final RuleCall cColumnNameSTRINGTerminalRuleCall_0 = (RuleCall)cColumnNameAssignment.eContents().get(0);
		
		//Item:
		//	columnName=STRING;
		@Override public ParserRule getRule() { return rule; }
		
		//columnName=STRING
		public Assignment getColumnNameAssignment() { return cColumnNameAssignment; }
		
		//STRING
		public RuleCall getColumnNameSTRINGTerminalRuleCall_0() { return cColumnNameSTRINGTerminalRuleCall_0; }
	}
	public class EvaluationElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "fr.istic.MML.Evaluation");
		private final Group cGroup = (Group)rule.eContents().get(1);
		private final Keyword cEvaluationKeyword_0 = (Keyword)cGroup.eContents().get(0);
		private final Assignment cStrategyEvaluationAssignment_1 = (Assignment)cGroup.eContents().get(1);
		private final RuleCall cStrategyEvaluationStrategyEvaluationParserRuleCall_1_0 = (RuleCall)cStrategyEvaluationAssignment_1.eContents().get(0);
		private final RuleCall cSEMICOLONParserRuleCall_2 = (RuleCall)cGroup.eContents().get(2);
		private final RuleCall cNEWLINEParserRuleCall_3 = (RuleCall)cGroup.eContents().get(3);
		
		//// Choose evaluation strategy
		//Evaluation:
		//	'evaluation'
		//	strategyEvaluation=StrategyEvaluation SEMICOLON NEWLINE?;
		@Override public ParserRule getRule() { return rule; }
		
		//'evaluation' strategyEvaluation=StrategyEvaluation SEMICOLON NEWLINE?
		public Group getGroup() { return cGroup; }
		
		//'evaluation'
		public Keyword getEvaluationKeyword_0() { return cEvaluationKeyword_0; }
		
		//strategyEvaluation=StrategyEvaluation
		public Assignment getStrategyEvaluationAssignment_1() { return cStrategyEvaluationAssignment_1; }
		
		//StrategyEvaluation
		public RuleCall getStrategyEvaluationStrategyEvaluationParserRuleCall_1_0() { return cStrategyEvaluationStrategyEvaluationParserRuleCall_1_0; }
		
		//SEMICOLON
		public RuleCall getSEMICOLONParserRuleCall_2() { return cSEMICOLONParserRuleCall_2; }
		
		//NEWLINE?
		public RuleCall getNEWLINEParserRuleCall_3() { return cNEWLINEParserRuleCall_3; }
	}
	public class StrategyEvaluationElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "fr.istic.MML.StrategyEvaluation");
		private final Alternatives cAlternatives = (Alternatives)rule.eContents().get(1);
		private final RuleCall cSimpleSplitParserRuleCall_0 = (RuleCall)cAlternatives.eContents().get(0);
		private final RuleCall cCrossValidationParserRuleCall_1 = (RuleCall)cAlternatives.eContents().get(1);
		
		//StrategyEvaluation:
		//	SimpleSplit | CrossValidation;
		@Override public ParserRule getRule() { return rule; }
		
		//SimpleSplit | CrossValidation
		public Alternatives getAlternatives() { return cAlternatives; }
		
		//SimpleSplit
		public RuleCall getSimpleSplitParserRuleCall_0() { return cSimpleSplitParserRuleCall_0; }
		
		//CrossValidation
		public RuleCall getCrossValidationParserRuleCall_1() { return cCrossValidationParserRuleCall_1; }
	}
	public class SimpleSplitElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "fr.istic.MML.SimpleSplit");
		private final Group cGroup = (Group)rule.eContents().get(1);
		private final Keyword cTrainingSetKeyword_0 = (Keyword)cGroup.eContents().get(0);
		private final Keyword cValidationPercentKeyword_1 = (Keyword)cGroup.eContents().get(1);
		private final Assignment cValidationPercentAssignment_2 = (Assignment)cGroup.eContents().get(2);
		private final RuleCall cValidationPercentINTTerminalRuleCall_2_0 = (RuleCall)cValidationPercentAssignment_2.eContents().get(0);
		
		//SimpleSplit:
		//	'TrainingSet' 'validationPercent' validationPercent=INT;
		@Override public ParserRule getRule() { return rule; }
		
		//'TrainingSet' 'validationPercent' validationPercent=INT
		public Group getGroup() { return cGroup; }
		
		//'TrainingSet'
		public Keyword getTrainingSetKeyword_0() { return cTrainingSetKeyword_0; }
		
		//'validationPercent'
		public Keyword getValidationPercentKeyword_1() { return cValidationPercentKeyword_1; }
		
		//validationPercent=INT
		public Assignment getValidationPercentAssignment_2() { return cValidationPercentAssignment_2; }
		
		//INT
		public RuleCall getValidationPercentINTTerminalRuleCall_2_0() { return cValidationPercentINTTerminalRuleCall_2_0; }
	}
	public class CrossValidationElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "fr.istic.MML.CrossValidation");
		private final Group cGroup = (Group)rule.eContents().get(1);
		private final Keyword cCrossValidationKeyword_0 = (Keyword)cGroup.eContents().get(0);
		private final Keyword cPartitionCountKeyword_1 = (Keyword)cGroup.eContents().get(1);
		private final Assignment cNumberAssignment_2 = (Assignment)cGroup.eContents().get(2);
		private final RuleCall cNumberINTTerminalRuleCall_2_0 = (RuleCall)cNumberAssignment_2.eContents().get(0);
		
		//CrossValidation:
		//	'CrossValidation'
		//	'partitionCount' number=INT;
		@Override public ParserRule getRule() { return rule; }
		
		//'CrossValidation' 'partitionCount' number=INT
		public Group getGroup() { return cGroup; }
		
		//'CrossValidation'
		public Keyword getCrossValidationKeyword_0() { return cCrossValidationKeyword_0; }
		
		//'partitionCount'
		public Keyword getPartitionCountKeyword_1() { return cPartitionCountKeyword_1; }
		
		//number=INT
		public Assignment getNumberAssignment_2() { return cNumberAssignment_2; }
		
		//INT
		public RuleCall getNumberINTTerminalRuleCall_2_0() { return cNumberINTTerminalRuleCall_2_0; }
	}
	
	public class MLFrameworkElements extends AbstractEnumRuleElementFinder {
		private final EnumRule rule = (EnumRule) GrammarUtil.findRuleForName(getGrammar(), "fr.istic.MML.MLFramework");
		private final EnumLiteralDeclaration cSCIKITLEARNEnumLiteralDeclaration = (EnumLiteralDeclaration)rule.eContents().get(1);
		private final Keyword cSCIKITLEARNScikitLearnKeyword_0 = (Keyword)cSCIKITLEARNEnumLiteralDeclaration.eContents().get(0);
		
		//enum MLFramework:
		//	SCIKITLEARN='Scikit-learn' /*| WEKA='Weka'*/;
		public EnumRule getRule() { return rule; }
		
		//SCIKITLEARN='Scikit-learn'
		public EnumLiteralDeclaration getSCIKITLEARNEnumLiteralDeclaration() { return cSCIKITLEARNEnumLiteralDeclaration; }
		
		//'Scikit-learn'
		public Keyword getSCIKITLEARNScikitLearnKeyword_0() { return cSCIKITLEARNScikitLearnKeyword_0; }
	}
	
	private final MMLModelElements pMMLModel;
	private final COMMAElements pCOMMA;
	private final SEMICOLONElements pSEMICOLON;
	private final NEWLINEElements pNEWLINE;
	private final DataInputElements pDataInput;
	private final CSVSeparatorElements pCSVSeparator;
	private final MLChoiceElements pMLChoice;
	private final MLFrameworkElements eMLFramework;
	private final MLAlgorithmElements pMLAlgorithm;
	private final RegressionTreeElements pRegressionTree;
	private final LinearRegressionElements pLinearRegression;
	private final VariablesElements pVariables;
	private final TargetElements pTarget;
	private final DefaultTargetElements pDefaultTarget;
	private final NamedTargetElements pNamedTarget;
	private final PredictionsElements pPredictions;
	private final AllVariablesElements pAllVariables;
	private final PredictorVariablesElements pPredictorVariables;
	private final ItemElements pItem;
	private final EvaluationElements pEvaluation;
	private final StrategyEvaluationElements pStrategyEvaluation;
	private final SimpleSplitElements pSimpleSplit;
	private final CrossValidationElements pCrossValidation;
	
	private final Grammar grammar;
	
	private final TerminalsGrammarAccess gaTerminals;

	@Inject
	public MMLGrammarAccess(GrammarProvider grammarProvider,
			TerminalsGrammarAccess gaTerminals) {
		this.grammar = internalFindGrammar(grammarProvider);
		this.gaTerminals = gaTerminals;
		this.pMMLModel = new MMLModelElements();
		this.pCOMMA = new COMMAElements();
		this.pSEMICOLON = new SEMICOLONElements();
		this.pNEWLINE = new NEWLINEElements();
		this.pDataInput = new DataInputElements();
		this.pCSVSeparator = new CSVSeparatorElements();
		this.pMLChoice = new MLChoiceElements();
		this.eMLFramework = new MLFrameworkElements();
		this.pMLAlgorithm = new MLAlgorithmElements();
		this.pRegressionTree = new RegressionTreeElements();
		this.pLinearRegression = new LinearRegressionElements();
		this.pVariables = new VariablesElements();
		this.pTarget = new TargetElements();
		this.pDefaultTarget = new DefaultTargetElements();
		this.pNamedTarget = new NamedTargetElements();
		this.pPredictions = new PredictionsElements();
		this.pAllVariables = new AllVariablesElements();
		this.pPredictorVariables = new PredictorVariablesElements();
		this.pItem = new ItemElements();
		this.pEvaluation = new EvaluationElements();
		this.pStrategyEvaluation = new StrategyEvaluationElements();
		this.pSimpleSplit = new SimpleSplitElements();
		this.pCrossValidation = new CrossValidationElements();
	}
	
	protected Grammar internalFindGrammar(GrammarProvider grammarProvider) {
		Grammar grammar = grammarProvider.getGrammar(this);
		while (grammar != null) {
			if ("fr.istic.MML".equals(grammar.getName())) {
				return grammar;
			}
			List<Grammar> grammars = grammar.getUsedGrammars();
			if (!grammars.isEmpty()) {
				grammar = grammars.iterator().next();
			} else {
				return null;
			}
		}
		return grammar;
	}
	
	@Override
	public Grammar getGrammar() {
		return grammar;
	}
	
	
	public TerminalsGrammarAccess getTerminalsGrammarAccess() {
		return gaTerminals;
	}

	
	//MMLModel:
	//	input=DataInput
	//	mlChoice=MLChoice
	//	variables=Variables
	//	evaluation=Evaluation;
	public MMLModelElements getMMLModelAccess() {
		return pMMLModel;
	}
	
	public ParserRule getMMLModelRule() {
		return getMMLModelAccess().getRule();
	}
	
	//fragment COMMA:
	//	',';
	public COMMAElements getCOMMAAccess() {
		return pCOMMA;
	}
	
	public ParserRule getCOMMARule() {
		return getCOMMAAccess().getRule();
	}
	
	//fragment SEMICOLON:
	//	';';
	public SEMICOLONElements getSEMICOLONAccess() {
		return pSEMICOLON;
	}
	
	public ParserRule getSEMICOLONRule() {
		return getSEMICOLONAccess().getRule();
	}
	
	//fragment NEWLINE:
	//	"\n";
	public NEWLINEElements getNEWLINEAccess() {
		return pNEWLINE;
	}
	
	public ParserRule getNEWLINERule() {
		return getNEWLINEAccess().getRule();
	}
	
	//// Read dataset
	//DataInput:
	//	'dataSet' file=STRING csvSeparator=CSVSeparator? SEMICOLON NEWLINE;
	public DataInputElements getDataInputAccess() {
		return pDataInput;
	}
	
	public ParserRule getDataInputRule() {
		return getDataInputAccess().getRule();
	}
	
	//CSVSeparator:
	//	'separator' separator=STRING;
	public CSVSeparatorElements getCSVSeparatorAccess() {
		return pCSVSeparator;
	}
	
	public ParserRule getCSVSeparatorRule() {
		return getCSVSeparatorAccess().getRule();
	}
	
	//// Choose ML Algorithm
	//MLChoice:
	//	'mlFramework' framework=MLFramework COMMA
	//	'mlAlgorithm' algorithm=MLAlgorithm SEMICOLON NEWLINE;
	public MLChoiceElements getMLChoiceAccess() {
		return pMLChoice;
	}
	
	public ParserRule getMLChoiceRule() {
		return getMLChoiceAccess().getRule();
	}
	
	//enum MLFramework:
	//	SCIKITLEARN='Scikit-learn' /*| WEKA='Weka'*/;
	public MLFrameworkElements getMLFrameworkAccess() {
		return eMLFramework;
	}
	
	public EnumRule getMLFrameworkRule() {
		return getMLFrameworkAccess().getRule();
	}
	
	//MLAlgorithm:
	//	RegressionTree | LinearRegression;
	public MLAlgorithmElements getMLAlgorithmAccess() {
		return pMLAlgorithm;
	}
	
	public ParserRule getMLAlgorithmRule() {
		return getMLAlgorithmAccess().getRule();
	}
	
	//RegressionTree:
	//	regressionTree='RegressionTree';
	public RegressionTreeElements getRegressionTreeAccess() {
		return pRegressionTree;
	}
	
	public ParserRule getRegressionTreeRule() {
		return getRegressionTreeAccess().getRule();
	}
	
	//LinearRegression:
	//	linearRegression='LinearRegression';
	public LinearRegressionElements getLinearRegressionAccess() {
		return pLinearRegression;
	}
	
	public ParserRule getLinearRegressionRule() {
		return getLinearRegressionAccess().getRule();
	}
	
	//// Specify predictions and target variables
	//Variables:
	//	'variables'
	//	'prediction' predictions=Predictions COMMA
	//	'target' target=Target SEMICOLON NEWLINE;
	public VariablesElements getVariablesAccess() {
		return pVariables;
	}
	
	public ParserRule getVariablesRule() {
		return getVariablesAccess().getRule();
	}
	
	//Target:
	//	DefaultTarget | NamedTarget;
	public TargetElements getTargetAccess() {
		return pTarget;
	}
	
	public ParserRule getTargetRule() {
		return getTargetAccess().getRule();
	}
	
	//DefaultTarget:
	//	default='default';
	public DefaultTargetElements getDefaultTargetAccess() {
		return pDefaultTarget;
	}
	
	public ParserRule getDefaultTargetRule() {
		return getDefaultTargetAccess().getRule();
	}
	
	//NamedTarget:
	//	target=Item;
	public NamedTargetElements getNamedTargetAccess() {
		return pNamedTarget;
	}
	
	public ParserRule getNamedTargetRule() {
		return getNamedTargetAccess().getRule();
	}
	
	//Predictions:
	//	AllVariables | PredictorVariables;
	public PredictionsElements getPredictionsAccess() {
		return pPredictions;
	}
	
	public ParserRule getPredictionsRule() {
		return getPredictionsAccess().getRule();
	}
	
	//AllVariables:
	//	all='all';
	public AllVariablesElements getAllVariablesAccess() {
		return pAllVariables;
	}
	
	public ParserRule getAllVariablesRule() {
		return getAllVariablesAccess().getRule();
	}
	
	//PredictorVariables:
	//	vars+=Item ("+" vars+=Item)*;
	public PredictorVariablesElements getPredictorVariablesAccess() {
		return pPredictorVariables;
	}
	
	public ParserRule getPredictorVariablesRule() {
		return getPredictorVariablesAccess().getRule();
	}
	
	//Item:
	//	columnName=STRING;
	public ItemElements getItemAccess() {
		return pItem;
	}
	
	public ParserRule getItemRule() {
		return getItemAccess().getRule();
	}
	
	//// Choose evaluation strategy
	//Evaluation:
	//	'evaluation'
	//	strategyEvaluation=StrategyEvaluation SEMICOLON NEWLINE?;
	public EvaluationElements getEvaluationAccess() {
		return pEvaluation;
	}
	
	public ParserRule getEvaluationRule() {
		return getEvaluationAccess().getRule();
	}
	
	//StrategyEvaluation:
	//	SimpleSplit | CrossValidation;
	public StrategyEvaluationElements getStrategyEvaluationAccess() {
		return pStrategyEvaluation;
	}
	
	public ParserRule getStrategyEvaluationRule() {
		return getStrategyEvaluationAccess().getRule();
	}
	
	//SimpleSplit:
	//	'TrainingSet' 'validationPercent' validationPercent=INT;
	public SimpleSplitElements getSimpleSplitAccess() {
		return pSimpleSplit;
	}
	
	public ParserRule getSimpleSplitRule() {
		return getSimpleSplitAccess().getRule();
	}
	
	//CrossValidation:
	//	'CrossValidation'
	//	'partitionCount' number=INT;
	public CrossValidationElements getCrossValidationAccess() {
		return pCrossValidation;
	}
	
	public ParserRule getCrossValidationRule() {
		return getCrossValidationAccess().getRule();
	}
	
	//terminal ID:
	//	'^'? ('a'..'z' | 'A'..'Z' | '_') ('a'..'z' | 'A'..'Z' | '_' | '0'..'9')*;
	public TerminalRule getIDRule() {
		return gaTerminals.getIDRule();
	}
	
	//terminal INT returns ecore::EInt:
	//	'0'..'9'+;
	public TerminalRule getINTRule() {
		return gaTerminals.getINTRule();
	}
	
	//terminal STRING:
	//	'"' ('\\' . | !('\\' | '"'))* '"' |
	//	"'" ('\\' . | !('\\' | "'"))* "'";
	public TerminalRule getSTRINGRule() {
		return gaTerminals.getSTRINGRule();
	}
	
	//terminal ML_COMMENT:
	//	'/*'->'*/';
	public TerminalRule getML_COMMENTRule() {
		return gaTerminals.getML_COMMENTRule();
	}
	
	//terminal SL_COMMENT:
	//	'//' !('\n' | '\r')* ('\r'? '\n')?;
	public TerminalRule getSL_COMMENTRule() {
		return gaTerminals.getSL_COMMENTRule();
	}
	
	//terminal WS:
	//	' ' | '\t' | '\r' | '\n'+;
	public TerminalRule getWSRule() {
		return gaTerminals.getWSRule();
	}
	
	//terminal ANY_OTHER:
	//	.;
	public TerminalRule getANY_OTHERRule() {
		return gaTerminals.getANY_OTHERRule();
	}
}
